# Основы программирования
## Уроки
1. Введение 

    * Алгоритмы и Блок-схемы
    * Код и данные
    * REPL
    * Переменные, типы данных, базовые операции, скобки, выражения
    * Литеральные и вычисляемые значения

2. Условия, Boolean, Логические операторы, Циклы
    
    * Boolean
    * Операторы сравнения
    * not, or, and, not-not 
    * Логические выражения
    * if, else
    * Тернарный оператор
    * switch

3. Массивы, строки и циклы
    
    * String и строковые операции
    * Array
    * Object как ассоциативный массив
    * for
    * while

4. Функции, области видимости 

    * Функции
    * Определение и выполнение оных
    * Параметры и возвращаемое значение
    * Функции высшего порядка

5. Отладка, декомпозиция кода и локализация проблем

    * Процесс
    * KISS
    * DRY
    * Developer Tools
    * Комментирование как инструмент отладки
    * Отладочный вывод
    * Пошаговая отладка

6. Замыкания

    * Цели и паттерны использования. Плюсы и минусы
    * Замыкание как объект
    * Мегатонна практики

